﻿using FluentValidation;
using InternshipSystem.Core.ValueObject;

namespace InternshipSystem.Api.Queries
{
    public class DocumentPublishRequest
    {
        public long? Id { get; set; }
        public string Description { get; set; }
        public byte[] Scan { get; set; }
        public DocumentType Type { get; set; }
        
        public class Validator : AbstractValidator<DocumentPublishRequest>
        {
            public Validator()
            {
                RuleFor(document => document.Scan).NotEmpty();
                RuleFor(document => document.Type).NotEmpty();
            }
        }
    }
}