﻿using FluentValidation;

namespace InternshipSystem.Api.Queries
{
    public class InternshipTypeFrom
    {
        public long? Id { get; set; }
        public string Type { get; set; }
        public string Description { get; set; }
        public string DescriptionEng { get; set; }
        
        public class Validator : AbstractValidator<InternshipTypeFrom>
        {
            public Validator()
            {
                RuleFor(t => t.Id).NotNull()
                    .When(t =>
                        string.IsNullOrEmpty(t.Description) || string.IsNullOrEmpty(t.Type) || string.IsNullOrEmpty(t.DescriptionEng));
                RuleFor(t => t.Type).NotEmpty()
                    .When(t => !t.Id.HasValue);
                RuleFor(t => t.Description).NotEmpty()
                    .When(t => !t.Id.HasValue);
                RuleFor(t => t.DescriptionEng).NotEmpty()
                    .When(t => !t.Id.HasValue);
            }
        }
    }
}